#!/usr/bin/python

# Download CryptoPhoto Python lib from https://cryptophoto.com/admin/api
from CryptoPhotoUtils import CryptoPhotoUtils
import cgi, hashlib, os

server      = "https://cryptophoto.com";
private_key = "xxx"; # Your CryptoPhoto Private API Key
public_key  = "yyy"; # Your CryptoPhoto Public API Key
salt        = "random-salt-string";
uid         = "userId"; # Your users internal ID

POST = cgi.FieldStorage()

step = 'login'
error = ''
sid = ''

if 'username' in POST:
  if POST['username'].value == 'demo':
    # do CryptoPhoto authentication
    step = 'cp_authentication'
  else:
    error = 'Login credentials invalid'
elif 'cryptophoto' in POST:
  step = 'cp_authentication'

  # check for POSTed CP Token codes
  if 'token_selector' in POST and (('token_response_field_row' in POST and 'token_response_field_col' in POST) or 'cp_phc' in POST):

    cp = CryptoPhotoUtils(server, private_key, public_key, hashlib.sha1(uid + salt).hexdigest())
    cp.verify_response(POST['token_selector'].value if 'token_selector' in POST else '',
               POST['token_response_field_row'].value if 'token_response_field_row' in POST else '',
               POST['token_response_field_col'].value if 'token_response_field_col' in POST else '',
               POST['cp_phc'].value if 'cp_phc' in POST else '',
               cgi.escape(os.environ["REMOTE_ADDR"]))

    if cp.is_valid:
      step = 'success'
    else:
      error = 'Codes invalid'
  else:
    error = 'Missing required codes. Invalid authentication'

if step == 'cp_authentication':

  cp = CryptoPhotoUtils(server, private_key, public_key, hashlib.sha1(uid + salt).hexdigest())
  cp.start_session(cgi.escape(os.environ["REMOTE_ADDR"]), True)

  if cp.is_valid:
    if cp.has_token:
      sid = cp.sid
    else:
      step = 'success'
  else:
    error = cp.error + cp.errdesc

display = ''

if error != '':
  display = '<p>Error: ' + error + '</p>';

if step == 'login':
  display += ('Username: <input type="text" name="username" value="demo"><br>'
    '<input type="submit" value="Login">')
elif step == 'cp_authentication':
  display += ('<input type="hidden" name="cryptophoto" value="1">'
    '<div id="cp_widget" style="margin: 10px auto;width:300px">Loading...</div>'
    '<input type="submit" value="Continue">'
    '<script type="text/javascript"'
    'src="' + server + '/api/challenge?sd=' + sid + '"></script>')
elif step == 'success':
  display += '<p>You have successfully login.</p>'

out = '''Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
<meta charset='UTF-8'>
<title>User Login</title>
</head>

<body style='text-align:center'>
  <h2>Login</h2>
  <form action='' method='post'>
    {display}
  </form>
</body>
</html>'''

out = out.format(display=display)

print out